/*
 *
 * Menu
 *
 */
#include <windows.h>

/* Deklaracja wyprzedzajca: funkcja obsugi okna */
LRESULT CALLBACK WindowProcedure(HWND, UINT, WPARAM, LPARAM);
void CreateMyMenu( HWND hwnd );
/* Nazwa klasy okna */
char szClassName[] = "PRZYKLAD";
HMENU hSubMenu;

int WINAPI WinMain(HINSTANCE hThisInstance, HINSTANCE hPrevInstance, 
                   LPSTR lpszArgument, int nFunsterStil)
{
    HWND hwnd;               /* Uchwyt okna */
    MSG messages;            /* Komunikaty okna */
    WNDCLASSEX wincl;        /* Struktura klasy okna */

    /* Klasa okna */
    wincl.hInstance     = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc   = WindowProcedure;    // wskanik na funkcj obsugi okna  
    wincl.style         = CS_DBLCLKS;                 
    wincl.cbSize        = sizeof(WNDCLASSEX);

    /* Domylna ikona i wskanik myszy */
    wincl.hIcon   = LoadIcon(NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor(NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL; 
    wincl.cbClsExtra = 0;   
    wincl.cbWndExtra = 0;   
    /* Jasnoszare to */
    wincl.hbrBackground = (HBRUSH)GetStockObject(LTGRAY_BRUSH);

    /* Rejestruj klas okna */
    if(!RegisterClassEx(&wincl)) return 0;

    /* Twrz okno */
    hwnd = CreateWindowEx(
           0,                   
           szClassName,         
           "Przykad",       
           WS_OVERLAPPEDWINDOW, 
           CW_USEDEFAULT,       
           CW_USEDEFAULT,       
           512,                 
           512,                 
           HWND_DESKTOP,        
           NULL,                
           hThisInstance,       
           NULL                 
           );

    CreateMyMenu( hwnd );
    ShowWindow(hwnd, nFunsterStil);
    /* Ptla obsugi komunikatw */
    while(GetMessage(&messages, NULL, 0, 0))
    {
           /* Tumacz kody rozszerzone */
           TranslateMessage(&messages);
           /* Obsu komunikat */
           DispatchMessage(&messages);
    }

    /* Zwr parametr podany w PostQuitMessage( ) */
    return messages.wParam;
}

/* T funkcj woa DispatchMessage( ) */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT message, 
                                 WPARAM wParam, LPARAM lParam)
{
    POINT point;

    switch (message)                  
    {
           case WM_DESTROY:
                PostQuitMessage(0);        
              break;
           case WM_RBUTTONUP:
                point.x = LOWORD (lParam) ;
                point.y = HIWORD (lParam) ;
                ClientToScreen (hwnd, &point) ;
					  
                TrackPopupMenu (hSubMenu, TPM_RIGHTBUTTON, point.x, point.y,
					            0, hwnd, NULL) ;
			  break;
           case WM_COMMAND:
                switch(LOWORD(wParam))
                {
                     case 101 : SendMessage( hwnd, WM_CLOSE, 0, 0 );break;
                }   
           default:                   
              return DefWindowProc(hwnd, message, wParam, lParam);
    }
    return 0;
}

void CreateMyMenu( HWND hwnd )
{
	HMENU hMenu;

	hMenu = CreateMenu () ;

	hSubMenu = CreateMenu () ;
	AppendMenu (hSubMenu, MF_STRING   , 100, "&Nowy") ;
	AppendMenu (hSubMenu, MF_SEPARATOR, 0  , NULL) ;
	AppendMenu (hSubMenu, MF_STRING   , 101, "&Koniec") ;
	AppendMenu (hMenu, MF_POPUP, hSubMenu, "&Plik") ;

	hSubMenu = CreateMenu () ;
	AppendMenu (hSubMenu, MF_STRING,    102,  "&Undo") ;
	AppendMenu (hSubMenu, MF_SEPARATOR, 0,    NULL) ;
	AppendMenu (hSubMenu, MF_STRING,    103,   "Re&do") ;
	AppendMenu (hMenu, MF_POPUP, hSubMenu, "&Edycja") ;

	SetMenu( hwnd, hMenu );
}
